// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{PatternSpec, PreferencesGroup};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPreferencesPage")]
    pub struct PreferencesPage(Object<ffi::DzlPreferencesPage, ffi::DzlPreferencesPageClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_preferences_page_get_type(),
    }
}

impl PreferencesPage {
    #[doc(alias = "dzl_preferences_page_add_group")]
    pub fn add_group(&self, group: &PreferencesGroup) {
        unsafe {
            ffi::dzl_preferences_page_add_group(self.to_glib_none().0, group.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_preferences_page_get_group")]
    #[doc(alias = "get_group")]
    pub fn group(&self, group_name: &str) -> Option<PreferencesGroup> {
        unsafe {
            from_glib_none(ffi::dzl_preferences_page_get_group(
                self.to_glib_none().0,
                group_name.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_page_refilter")]
    pub fn refilter(&self, spec: &PatternSpec) {
        unsafe {
            ffi::dzl_preferences_page_refilter(self.to_glib_none().0, spec.to_glib_none().0);
        }
    }

    //#[doc(alias = "dzl_preferences_page_set_map")]
    //pub fn set_map(&self, map: /*Unknown conversion*//*Unimplemented*/HashTable TypeId { ns_id: 0, id: 25 }/TypeId { ns_id: 0, id: 25 }) {
    //    unsafe { TODO: call ffi:dzl_preferences_page_set_map() }
    //}

    pub fn priority(&self) -> i32 {
        ObjectExt::property(self, "priority")
    }

    pub fn set_priority(&self, priority: i32) {
        ObjectExt::set_property(self, "priority", priority)
    }

    #[doc(alias = "priority")]
    pub fn connect_priority_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_priority_trampoline<F: Fn(&PreferencesPage) + 'static>(
            this: *mut ffi::DzlPreferencesPage,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::priority\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_priority_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for PreferencesPage {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PreferencesPage")
    }
}
